# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 1.4.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from pydantic import BaseModel
from pydantic import Field
from pydantic import StrictStr

from superwise_api.client.models.model_id import ModelId
from superwise_api.client.models.prompt import Prompt


class ApplicationResponse(BaseModel):
    """
    ApplicationResponse
    """

    id: Optional[StrictStr] = None
    created_at: Optional[datetime] = None
    updated_at: Optional[datetime] = None
    model_id: Optional[ModelId] = None
    name: StrictStr = Field(...)
    prompt: Optional[Prompt] = None
    dataset_id: StrictStr = Field(...)
    __properties = ["id", "created_at", "updated_at", "model_id", "name", "prompt", "dataset_id"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ApplicationResponse:
        """Create an instance of ApplicationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of model_id
        if self.model_id:
            _dict["model_id"] = self.model_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of prompt
        if self.prompt:
            _dict["prompt"] = self.prompt.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ApplicationResponse:
        """Create an instance of ApplicationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ApplicationResponse.parse_obj(obj)

        _obj = ApplicationResponse.parse_obj(
            {
                "id": obj.get("id"),
                "created_at": obj.get("created_at"),
                "updated_at": obj.get("updated_at"),
                "model_id": ModelId.from_dict(obj.get("model_id")) if obj.get("model_id") is not None else None,
                "name": obj.get("name"),
                "prompt": Prompt.from_dict(obj.get("prompt")) if obj.get("prompt") is not None else None,
                "dataset_id": obj.get("dataset_id"),
            }
        )
        return _obj
