# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 1.4.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic import BaseModel
from pydantic import StrictStr
from pydantic import validator


class AWSCredentialsResponse(BaseModel):
    """
    AWSCredentialsResponse
    """

    credentials_type: Optional[StrictStr] = "AWS"
    aws_access_key_id: Optional[StrictStr] = None
    aws_secret_access_key: Optional[StrictStr] = None
    __properties = ["credentials_type", "aws_access_key_id", "aws_secret_access_key"]

    @validator("credentials_type")
    def credentials_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("AWS"):
            raise ValueError("must be one of enum values ('AWS')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AWSCredentialsResponse:
        """Create an instance of AWSCredentialsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AWSCredentialsResponse:
        """Create an instance of AWSCredentialsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AWSCredentialsResponse.parse_obj(obj)

        _obj = AWSCredentialsResponse.parse_obj(
            {
                "credentials_type": obj.get("credentials_type") if obj.get("credentials_type") is not None else "AWS",
                "aws_access_key_id": obj.get("aws_access_key_id"),
                "aws_secret_access_key": obj.get("aws_secret_access_key"),
            }
        )
        return _obj
