# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 1.4.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from inspect import getfullargspec
from typing import Any
from typing import List
from typing import Optional
from typing import TYPE_CHECKING
from typing import Union

from pydantic import BaseModel
from pydantic import Field
from pydantic import StrictStr
from pydantic import ValidationError
from pydantic import validator

from superwise_api.client.models.vertex_ai_model_garden_embedding_model import VertexAIModelGardenEmbeddingModel

EMBEDDINGMODEL_ONE_OF_SCHEMAS = ["VertexAIModelGardenEmbeddingModel"]


class EmbeddingModel(BaseModel):
    """
    EmbeddingModel
    """

    # data type: VertexAIModelGardenEmbeddingModel
    oneof_schema_1_validator: Optional[VertexAIModelGardenEmbeddingModel] = None
    if TYPE_CHECKING:
        actual_instance: Union[VertexAIModelGardenEmbeddingModel]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(EMBEDDINGMODEL_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = EmbeddingModel.construct()
        error_messages = []
        match = 0
        # validate data type: VertexAIModelGardenEmbeddingModel
        if not isinstance(v, VertexAIModelGardenEmbeddingModel):
            error_messages.append(f"Error! Input type `{type(v)}` is not `VertexAIModelGardenEmbeddingModel`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in EmbeddingModel with oneOf schemas: VertexAIModelGardenEmbeddingModel. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in EmbeddingModel with oneOf schemas: VertexAIModelGardenEmbeddingModel. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> EmbeddingModel:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> EmbeddingModel:
        """Returns the object represented by the json string"""
        instance = EmbeddingModel.construct()
        error_messages = []
        match = 0

        # deserialize data into VertexAIModelGardenEmbeddingModel
        try:
            instance.actual_instance = VertexAIModelGardenEmbeddingModel.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into EmbeddingModel with oneOf schemas: VertexAIModelGardenEmbeddingModel. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into EmbeddingModel with oneOf schemas: VertexAIModelGardenEmbeddingModel. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())
