# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 1.4.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401

from pydantic import BaseModel
from pydantic import Field
from pydantic import StrictStr

from superwise_api.client.models.model_provider import ModelProvider
from superwise_api.client.models.model_version_response import ModelVersionResponse


class ModelCreate(BaseModel):
    """
    ModelCreate
    """

    provider: ModelProvider = Field(...)
    version: ModelVersionResponse = Field(...)
    api_token: StrictStr = Field(...)
    __properties = ["provider", "version", "api_token"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ModelCreate:
        """Create an instance of ModelCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of version
        if self.version:
            _dict["version"] = self.version.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ModelCreate:
        """Create an instance of ModelCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ModelCreate.parse_obj(obj)

        _obj = ModelCreate.parse_obj(
            {
                "provider": obj.get("provider"),
                "version": ModelVersionResponse.from_dict(obj.get("version"))
                if obj.get("version") is not None
                else None,
                "api_token": obj.get("api_token"),
            }
        )
        return _obj
