# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 1.4.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic import BaseModel
from pydantic import Field
from pydantic import StrictStr
from pydantic import validator

from superwise_api.client.models.azure_credentials_request import AzureCredentialsRequest
from superwise_api.client.models.source_azure_params import SourceAzureParams


class SourceCreateAzure(BaseModel):
    """
    SourceCreateAzure
    """

    name: StrictStr = Field(...)
    type: Optional[StrictStr] = "AZURE_BLOB_STORAGE"
    credentials: AzureCredentialsRequest = Field(...)
    params: SourceAzureParams = Field(...)
    __properties = ["name", "type", "credentials", "params"]

    @validator("type")
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("AZURE_BLOB_STORAGE"):
            raise ValueError("must be one of enum values ('AZURE_BLOB_STORAGE')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SourceCreateAzure:
        """Create an instance of SourceCreateAzure from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of credentials
        if self.credentials:
            _dict["credentials"] = self.credentials.to_dict()
        # override the default output from pydantic by calling `to_dict()` of params
        if self.params:
            _dict["params"] = self.params.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SourceCreateAzure:
        """Create an instance of SourceCreateAzure from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SourceCreateAzure.parse_obj(obj)

        _obj = SourceCreateAzure.parse_obj(
            {
                "name": obj.get("name"),
                "type": obj.get("type") if obj.get("type") is not None else "AZURE_BLOB_STORAGE",
                "credentials": AzureCredentialsRequest.from_dict(obj.get("credentials"))
                if obj.get("credentials") is not None
                else None,
                "params": SourceAzureParams.from_dict(obj.get("params")) if obj.get("params") is not None else None,
            }
        )
        return _obj
