# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 1.4.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from pydantic import BaseModel
from pydantic import Field
from pydantic import StrictStr
from pydantic import validator

from superwise_api.client.models.aws_credentials_response import AWSCredentialsResponse
from superwise_api.client.models.source_s3_params import SourceS3Params


class SourceGetS3(BaseModel):
    """
    SourceGetS3
    """

    id: StrictStr = Field(...)
    name: StrictStr = Field(...)
    created_at: Optional[datetime] = None
    updated_at: Optional[datetime] = None
    created_by: StrictStr = Field(...)
    type: StrictStr = Field(...)
    params: SourceS3Params = Field(...)
    credentials: AWSCredentialsResponse = Field(...)
    __properties = ["id", "name", "created_at", "updated_at", "created_by", "type", "params", "credentials"]

    @validator("type")
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ("S3"):
            raise ValueError("must be one of enum values ('S3')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SourceGetS3:
        """Create an instance of SourceGetS3 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of params
        if self.params:
            _dict["params"] = self.params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of credentials
        if self.credentials:
            _dict["credentials"] = self.credentials.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SourceGetS3:
        """Create an instance of SourceGetS3 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SourceGetS3.parse_obj(obj)

        _obj = SourceGetS3.parse_obj(
            {
                "id": obj.get("id"),
                "name": obj.get("name"),
                "created_at": obj.get("created_at"),
                "updated_at": obj.get("updated_at"),
                "created_by": obj.get("created_by"),
                "type": obj.get("type"),
                "params": SourceS3Params.from_dict(obj.get("params")) if obj.get("params") is not None else None,
                "credentials": AWSCredentialsResponse.from_dict(obj.get("credentials"))
                if obj.get("credentials") is not None
                else None,
            }
        )
        return _obj
