# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 1.4.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import List

from pydantic import BaseModel
from pydantic import conlist
from pydantic import Field
from pydantic import StrictStr

from superwise_api.client.models.ask_config import AskConfig
from superwise_api.client.models.chat_history_entry import ChatHistoryEntry


class AskRequestPayload(BaseModel):
    """
    AskRequestPayload
    """

    config: AskConfig = Field(..., description="The application configuration.")
    input: StrictStr = Field(..., description="The user's current message or question to the AI agent.")
    chat_history: conlist(ChatHistoryEntry) = Field(
        ..., description="The existing conversation history with the AI agent."
    )
    __properties = ["config", "input", "chat_history"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AskRequestPayload:
        """Create an instance of AskRequestPayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of config
        if self.config:
            _dict["config"] = self.config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in chat_history (list)
        _items = []
        if self.chat_history:
            for _item in self.chat_history:
                if _item:
                    _items.append(_item.to_dict())
            _dict["chat_history"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AskRequestPayload:
        """Create an instance of AskRequestPayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AskRequestPayload.parse_obj(obj)

        _obj = AskRequestPayload.parse_obj(
            {
                "config": AskConfig.from_dict(obj.get("config")) if obj.get("config") is not None else None,
                "input": obj.get("input"),
                "chat_history": [ChatHistoryEntry.from_dict(_item) for _item in obj.get("chat_history")]
                if obj.get("chat_history") is not None
                else None,
            }
        )
        return _obj
